/*
 * Copyright (C) 2013 Joos Kiener <Joos.Kiener@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.bitbucket.kienerj.moleculedatabaseframework.security;

import lombok.Data;
import org.springframework.security.core.Authentication;

/**
 * <p>
 * Basic implementation of <code>Permission</code>.
 * </p>
 * <p>
 * See {@link org.bitbucket.kienerj.moleculedatabaseframework.security.Permission}
 * for further information.
 * </p>
 *
 * @author Joos Kiener <Joos.Kiener@gmail.com>
 */
@Data
public abstract class AbstractPermission implements Permission {

    private final String targetType;


    public AbstractPermission(String targetType){
        this.targetType = targetType;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public abstract boolean isAllowed(Authentication authentication,
        Object targetDomainObject, String permissionType, String permissionTarget);
}
