/*
 * Copyright (C) 2013 Joos Kiener <Joos.Kiener@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.bitbucket.kienerj.moleculedatabaseframework.service;

import java.util.Map;
import lombok.Getter;

/**
 * <p>
 * Contains a mapping of "constraint description" to value of all fields violating a
 * unique constraint in the database.
 * </p>
 * <p>
 * "constraint description" is a either a field name or a description of the
 * constraitn in case of a multi-field constraint.
 * </p>
 *
 * @author Joos Kiener <Joos.Kiener@gmail.com>
 */
public class UniquenesscheckResult {

    @Getter
    private final Map<String, Object> violatedContraints;
    @Getter
    private final boolean isUnique;

    public UniquenesscheckResult(boolean isUnique, Map<String, Object> violatedContraints){
        this.isUnique = isUnique;
        this.violatedContraints = violatedContraints;
    }
}
