/*
 *  Copyright (C) 2012 Joos Kiener <Joos.Kiener@gmail.com>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.

 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.bitbucket.kienerj.moleculedatabaseframework.sql;

import org.hibernate.dialect.PostgreSQL82Dialect;
import org.hibernate.dialect.function.SQLFunctionTemplate;
import org.hibernate.type.StandardBasicTypes;

/**
 *
 * @author Joos Kiener <Joos.Kiener@gmail.com>
 */
public class BingoPostgreSQLDialect extends PostgreSQL82Dialect {

    public BingoPostgreSQLDialect() {
        super();
        registerFunction("issubstructure", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1  @ (?2, ?3)::bingo.sub"));
        registerFunction("isexactstructure", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1  @ (?2, ?3)::bingo.exact"));
        registerFunction("matchessmarts", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1  @ (?2, ?3)::bingo.smarts"));
        registerFunction("matchesformula", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1  @ (?2, ?3)::bingo.gross"));
        registerFunction("issimilarstructure", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1  @ (?2, ?3, ?4, ?5)::bingo.sim"));
        registerFunction("hasmassbetween", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "?1 > ?2::bingo.mass AND ?1 < ?3::bingo.mass"));
        registerFunction("matchsub", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "bingo.matchSub(?1, (?2, ?3))"));
        registerFunction("matchsmarts", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "bingo.matchSmarts(?1, (?2, ?3))"));
        registerFunction("matchgross", new SQLFunctionTemplate(
                StandardBasicTypes.BOOLEAN, "bingo.matchGross(?1, (?2, ?3))"));
    }
}
